#! /usr/bin/env python3
# coding: utf8

from math import pi, sin, cos, tan, atan, sqrt

# Ce listing n'est comprehensible que si on l'accompagne
# du schema variables_mur_sud_recto.png

def principal ():
    # hauteurDeuxEtages = 10.0
    sousRezDeChaussee = 1.2
    sousFenetre = 0.85
    hauteurFenetre = 1.75
    entreFenetreEtPlafond = 0.3
    hauteurUnEtage = 2.85
    entreEtages = 0.25
    
    inclinaisonToitDeg = 30.0
    inclinaisonToitRad = inclinaisonToitDeg * pi / 180.0

    largeurMaison = 10.0
    largeurPorte = 1.5
    largeurFenetre = 1.1
    deFenetreAMur = largeurMaison / 4 - largeurFenetre
    entreFenetres = (largeurMaison - largeurPorte) / 2 - (deFenetreAMur + largeurFenetre)
    
    hauteurToit = (largeurMaison / 2) * tan(inclinaisonToitRad)
    
    alfa = 0.0
    bravo = alfa + sousRezDeChaussee
    charlie = bravo + sousFenetre
    delta = charlie + hauteurFenetre
    echo = delta + entreFenetreEtPlafond
    foxtrot = echo + entreEtages
    golf = foxtrot + sousFenetre
    hotel = golf + hauteurFenetre
    india = hotel + entreFenetreEtPlafond + entreEtages
    juliet = india + hauteurToit
    altMidIndiaJuliet = india + hauteurToit / 2
    
    kilo = 0.0 - (largeurMaison / 2)
    lima = kilo + deFenetreAMur
    mike = lima + largeurFenetre
    november = mike + entreFenetres
    oscar = november + largeurPorte
    papa = oscar + entreFenetres
    quebec = papa + largeurFenetre
    romeo = largeurMaison / 2

    """
    if romeo != quebec + deFenetreAMur:
        print("*** Romeo est a la fois en %f et en %f." % (romeo, quebec + deFenetreAMur))
    else:
        print("Pas de problème pour Roméo.")
    """
    
    print("<points3D>")
    
    affichePointY0(1, kilo, alfa)
    affichePointY0(2, mike, alfa)
    affichePointY0(3, 0.0, alfa)
    affichePointY0(4, papa, alfa)
    affichePointY0(5, romeo, alfa)
    
    affichePointY0(6, lima, charlie)
    affichePointY0(7, mike, charlie)
    affichePointY0(8, november, bravo)
    affichePointY0(9, oscar, bravo)
    affichePointY0(10, papa, charlie)
    affichePointY0(11, quebec, charlie)
    
    affichePointY0(12, lima, delta)
    affichePointY0(13, mike, delta)
    affichePointY0(14, november, delta)
    affichePointY0(15, oscar, delta)
    affichePointY0(16, papa, delta)
    affichePointY0(17, quebec, delta)
    
    affichePointY0(18, kilo, echo)
    affichePointY0(19, mike, echo)
    affichePointY0(20, 0.0, echo)
    affichePointY0(21, papa, echo)
    affichePointY0(22, romeo, echo)
    
    affichePointY0(23, lima, golf)
    affichePointY0(24, mike, golf)
    affichePointY0(25, november, foxtrot)
    affichePointY0(26, oscar, foxtrot)
    affichePointY0(27, papa, golf)
    affichePointY0(28, quebec, golf)
    
    affichePointY0(29, lima, hotel)
    affichePointY0(30, mike, hotel)
    affichePointY0(31, november, hotel)
    affichePointY0(32, oscar, hotel)
    affichePointY0(33, papa, hotel)
    affichePointY0(34, quebec, hotel)
    
    affichePointY0(35, kilo, india)
    affichePointY0(36, mike, india)
    affichePointY0(37, 0.0, india)
    affichePointY0(38, papa, india)
    affichePointY0(39, romeo, india)
    
    affichePointY0(40, mike, altMidIndiaJuliet)
    affichePointY0(41, papa, altMidIndiaJuliet)
    affichePointY0(42, 0.0, juliet)
    
    print("</points3D>")
    
    print("<faces>")
    print("1,2,7,6")
    print("2,3,8,7")
    print("3,9,8")
    print("3,4,10,9")
    print("4,5,11,10")
    print("1,6,12,18")
    print("7,8,14,13")
    print("9,10,16,15")
    print("11,5,22,17")
    print("12,13,19,18")
    print("13,14,20,19")
    print("14,15,20")
    print("15,16,21,20")
    print("16,17,22,21")
    print("18,19,24,23")
    print("19,20,25,24")
    print("20,26,25")
    print("20,21,27,26")
    print("21,22,28,27")
    print("18,23,29,35")
    print("24,25,31,30")
    print("26,27,33,32")
    print("28,22,39,34")
    print("29,30,36,35")
    print("30,31,37,36")
    print("31,32,37")
    print("32,33,38,37")
    print("33,34,39,38")
    print("35,36,40")
    print("36,37,42,40")
    print("37,38,41,42")
    print("38,39,41")
    print("</faces>")
    
def affichePoint (num, xrays, yankee, zulu):
    print("%d,%f,%f,%f" % (num, xrays, yankee, zulu))

def affichePointY0 (num, xrays, zulu):
    affichePoint(num, xrays, 0.0, zulu)

principal()
