#! /usr/bin/env python3
# coding: utf8

from math import pi, sin, cos, tan, atan, sqrt

# Ce listing n'est comprehensible que si on l'accompagne
# du schema variables_mur_sud.png... mais alors il se révèle
# très simple.
#
# Les dimensions sont généralement décalquées (avec quelques
# adaptations minimes) des notes prises dans le fichier
# pallud_dimensions.org

def principal ():
    largeurMaison = 8.99
    hauteurMaison = 9.28 # Estimation, certainement à revoir
    
    hauteurFenetre = 1.655
    hauteurEtage0 = 2.86
    hauteurEtage1 = 2.625
    largeurPorte = 1.0
    largeurFenetre = 0.9
    entreFenetres = 1.51 # En fait, entre une fenetre latérale et la porte ou
                         # la porte-fenêtre centrale
    entreEtages = 0.25 # Epaisseur d'un plafond-plancher; pifomètre
    sousFenetre = 0.8 # Hélas non mesuré, mais le bas de la menuiserie des panneaux
                      # de la fenêtre de la salle à manger était exactement au niveau
                      # du plateau de la table... et il faut tenir compte de quelques
                      # centimetres de menuiserie du cadre de la fenêtre par rapport
                      # au support de granit

    entreFenetreEtPlafondEtage0 = hauteurEtage0 - sousFenetre - hauteurFenetre
    entreFenetreEtPlafondEtage1 = hauteurEtage1 - sousFenetre - hauteurFenetre
    
    inclinaisonToitDeg = 30.0 # Pifomètre
    inclinaisonToitRad = inclinaisonToitDeg * pi / 180.0

    hauteurToit = (largeurMaison / 2) * tan(inclinaisonToitRad)
    hauteurDeuxEtages = hauteurEtage0 + entreEtages + hauteurEtage1

    # Les deux éléments qui suivent sont calculés de façon à ce que
    # tout tombe juste.
    deFenetreAMur = (largeurMaison - 2 * largeurFenetre - 2 * entreFenetres - largeurPorte) / 2
    sousRezDeChaussee = hauteurMaison - hauteurToit - hauteurDeuxEtages
    
    # Calcul des cotes indiquées sur le schéma
    alfa = 0.0
    bravo = alfa + sousRezDeChaussee
    charlie = bravo + sousFenetre
    delta = charlie + hauteurFenetre
    echo = delta + entreFenetreEtPlafondEtage0
    foxtrot = echo + entreEtages
    golf = foxtrot + sousFenetre
    hotel = golf + hauteurFenetre
    india = hotel + entreFenetreEtPlafondEtage1 + entreEtages
    juliet = india + hauteurToit
    altMidIndiaJuliet = india + hauteurToit / 2
    
    kilo = 0.0 - (largeurMaison / 2)
    lima = kilo + deFenetreAMur
    mike = lima + largeurFenetre
    mikePrime = 0.0 - largeurMaison / 4 # Milieu d'un pan de toit
    november = mike + entreFenetres
    oscar = november + largeurPorte
    papa = oscar + entreFenetres
    papaPrime = largeurMaison / 4 # Milieu d'un pan de toit
    quebec = papa + largeurFenetre
    romeo = largeurMaison / 2
    
    print("<points3D>")
    
    # Recto
    affichePointY0(1, kilo, alfa)
    affichePointY0(2, mike, alfa)
    affichePointY0(3, 0.0, alfa)
    affichePointY0(4, papa, alfa)
    affichePointY0(5, romeo, alfa)
    
    affichePointY0(6, lima, charlie)
    affichePointY0(7, mike, charlie)
    affichePointY0(8, november, bravo)
    affichePointY0(9, oscar, bravo)
    affichePointY0(10, papa, charlie)
    affichePointY0(11, quebec, charlie)
    
    affichePointY0(12, lima, delta)
    affichePointY0(13, mike, delta)
    affichePointY0(14, november, delta)
    affichePointY0(15, oscar, delta)
    affichePointY0(16, papa, delta)
    affichePointY0(17, quebec, delta)
    
    affichePointY0(18, kilo, echo)
    affichePointY0(19, mike, echo)
    affichePointY0(20, 0.0, echo)
    affichePointY0(21, papa, echo)
    affichePointY0(22, romeo, echo)
    
    affichePointY0(23, lima, golf)
    affichePointY0(24, mike, golf)
    affichePointY0(25, november, foxtrot)
    affichePointY0(26, oscar, foxtrot)
    affichePointY0(27, papa, golf)
    affichePointY0(28, quebec, golf)
    
    affichePointY0(29, lima, hotel)
    affichePointY0(30, mike, hotel)
    affichePointY0(31, november, hotel)
    affichePointY0(32, oscar, hotel)
    affichePointY0(33, papa, hotel)
    affichePointY0(34, quebec, hotel)
    
    affichePointY0(35, kilo, india)
    affichePointY0(36, mike, india)
    affichePointY0(37, 0.0, india)
    affichePointY0(38, papa, india)
    affichePointY0(39, romeo, india)
    
    affichePointY0(40, mikePrime, altMidIndiaJuliet)
    affichePointY0(41, papaPrime, altMidIndiaJuliet)
    affichePointY0(42, 0.0, juliet)
    
    # Verso
    affichePointY1(1, kilo, alfa)
    affichePointY1(2, mike, alfa)
    affichePointY1(3, 0.0, alfa)
    affichePointY1(4, papa, alfa)
    affichePointY1(5, romeo, alfa)
    
    affichePointY1(6, lima, charlie)
    affichePointY1(7, mike, charlie)
    affichePointY1(8, november, bravo)
    affichePointY1(9, oscar, bravo)
    affichePointY1(10, papa, charlie)
    affichePointY1(11, quebec, charlie)
    
    affichePointY1(12, lima, delta)
    affichePointY1(13, mike, delta)
    affichePointY1(14, november, delta)
    affichePointY1(15, oscar, delta)
    affichePointY1(16, papa, delta)
    affichePointY1(17, quebec, delta)
    
    affichePointY1(18, kilo, echo)
    affichePointY1(19, mike, echo)
    affichePointY1(20, 0.0, echo)
    affichePointY1(21, papa, echo)
    affichePointY1(22, romeo, echo)
    
    affichePointY1(23, lima, golf)
    affichePointY1(24, mike, golf)
    affichePointY1(25, november, foxtrot)
    affichePointY1(26, oscar, foxtrot)
    affichePointY1(27, papa, golf)
    affichePointY1(28, quebec, golf)
    
    affichePointY1(29, lima, hotel)
    affichePointY1(30, mike, hotel)
    affichePointY1(31, november, hotel)
    affichePointY1(32, oscar, hotel)
    affichePointY1(33, papa, hotel)
    affichePointY1(34, quebec, hotel)
    
    affichePointY1(35, kilo, india)
    affichePointY1(36, mike, india)
    affichePointY1(37, 0.0, india)
    affichePointY1(38, papa, india)
    affichePointY1(39, romeo, india)
    
    affichePointY1(40, mikePrime, altMidIndiaJuliet)
    affichePointY1(41, papaPrime, altMidIndiaJuliet)
    affichePointY1(42, 0.0, juliet)
    
    print("</points3D>")
    
    print("<faces>")

    # Recto
    print("1,2,7,6")
    print("2,3,8,7")
    print("3,9,8")
    print("3,4,10,9")
    print("4,5,11,10")
    print("1,6,12,18")
    print("7,8,14,13")
    print("9,10,16,15")
    print("11,5,22,17")
    print("12,13,19,18")
    print("13,14,20,19")
    print("14,15,20")
    print("15,16,21,20")
    print("16,17,22,21")
    print("18,19,24,23")
    print("19,20,25,24")
    print("20,26,25")
    print("20,21,27,26")
    print("21,22,28,27")
    print("18,23,29,35")
    print("24,25,31,30")
    print("26,27,33,32")
    print("28,22,39,34")
    print("29,30,36,35")
    print("30,31,37,36")
    print("31,32,37")
    print("32,33,38,37")
    print("33,34,39,38")
    print("35,36,40")
    print("36,37,42,40")
    print("37,38,41,42")
    print("38,39,41")

    # Entourage fenêtres
    print("6,7,49,48")
    print("7,13,55,49")
    print("55,13,12,54")
    print("6,48,54,12")
    print("8,9,51,50")
    print("51,9,15,57")
    print("14,56,57,15")
    print("8,50,56,14")
    print("10,11,53,52")
    print("53,11,17,59")
    print("58,59,17,16")
    print("10,52,58,16")
    print("27,28,70,69")
    print("70,28,34,76")
    print("76,34,33,75")
    print("27,69,75,33")
    print("25,26,68,67")
    print("68,26,32,74")
    print("74,32,31,73")
    print("25,67,73,31")
    print("23,24,66,65")
    print("66,24,30,72")
    print("71,72,30,29")
    print("23,65,71,29")
    
    # Tranche
    print("1,43,44,2")
    print("2,44,45,3")
    print("3,45,46,4")
    print("4,46,47,5")
    print("5,47,64,22")
    print("22,64,81,39")
    print("39,81,83,41")
    print("41,83,84,42")
    print("43,1,18,60")
    print("60,18,35,77")
    print("77,35,40,82")
    print("82,40,42,84")
    
    # Verso
    printFaceVerso("1,2,7,6")
    printFaceVerso("2,3,8,7")
    printFaceVerso("3,9,8")
    printFaceVerso("3,4,10,9")
    printFaceVerso("4,5,11,10")
    printFaceVerso("1,6,12,18")
    printFaceVerso("7,8,14,13")
    printFaceVerso("9,10,16,15")
    printFaceVerso("11,5,22,17")
    printFaceVerso("12,13,19,18")
    printFaceVerso("13,14,20,19")
    printFaceVerso("14,15,20")
    printFaceVerso("15,16,21,20")
    printFaceVerso("16,17,22,21")
    printFaceVerso("18,19,24,23")
    printFaceVerso("19,20,25,24")
    printFaceVerso("20,26,25")

    # printFaceVerso("20,21,27,26")
    # Je remplace cette ligne pourtant valide a priori par les deux
    # suivantes, à cause d'une saleté à l'affichage sous Blender
    printFaceVerso("20,21,26")
    printFaceVerso("21,27,26")

    printFaceVerso("21,22,28,27")
    printFaceVerso("18,23,29,35")
    printFaceVerso("24,25,31,30")
    printFaceVerso("26,27,33,32")
    printFaceVerso("28,22,39,34")
    printFaceVerso("29,30,36,35")
    printFaceVerso("30,31,37,36")
    printFaceVerso("31,32,37")
    printFaceVerso("32,33,38,37")
    printFaceVerso("33,34,39,38")
    printFaceVerso("35,36,40")
    printFaceVerso("36,37,42,40")
    printFaceVerso("37,38,41,42")
    printFaceVerso("38,39,41")
    
    print("</faces>")
    
def affichePoint (num, xrays, yankee, zulu):
    print("%d,%f,%f,%f" % (num, xrays, yankee, zulu))

def affichePointY0 (num, xrays, zulu):
    affichePoint(num, xrays, 0.0, zulu)

def affichePointY1 (num, xrays, zulu):
    affichePoint(num + nbPointsSurUneFace, xrays, epaisseurMur, zulu)
    
def printFaceVerso (maLigne):
    # Tout cela paraît bien compliqué... il s'agit seulement de faire
    # en sorte que les faces verso aient elles aussi leur périmètre
    # décrit dans le sens géométrique (inverse des aiguilles d'une
    # montre)
    mesBazars = maLigne.split(',')
    pointOrigine = int(mesBazars[0]) + nbPointsSurUneFace
    maLigne2 = "%d," % (pointOrigine)
    for numTruc in range(len(mesBazars) - 1, 0, -1):
        numAugmente = int(mesBazars[numTruc]) + nbPointsSurUneFace
        maLigne2 += "%d" % (numAugmente)
        if numTruc > 1:
            maLigne2 += ","
    print(maLigne2)

# Deux variables globales. C'est inélégant, mais ça fait le job.
epaisseurMur = 0.2
nbPointsSurUneFace = 42 # Pourquoi? Voir schéma.

principal()
